#include "Mesh.h"

//
//
//
Mesh::Mesh(int rows = 1, int columns = 1) : _rows(rows), _cols(columns)
{ m = new MeshNode[_rows * _cols]; }

//
//
//
Mesh::Mesh(Mesh & rhs)
{
	if(this != &rhs)
	{
		_rows = rhs._rows;
		_cols = rhs._cols;
		int mat_size = _rows * _cols;
		delete [] m;
		m = new MeshNode[mat_size];
		for(int ix = 0; ix < mat_size; ++ix )
			m[ix] = rhs.m[ix]; 
    }
}

//
//
//
Mesh & Mesh::operator = (Mesh & rhs)
{
	if(this != &rhs)
	{
		_rows = rhs._rows; 
		_cols = rhs._cols;
		int mat_size = _rows * _cols;
		delete [] m;
		m = new MeshNode[mat_size];
		for(int ix = 0; ix < mat_size; ++ix)
			m[ix] = rhs.m[ix]; 
	}
	return *this;
}

//
//
//
void Mesh::X(int r, int c, float xx)
{
	this->m[r * _cols + c].X(xx);
}

//
//
//
void Mesh::Y(int r, int c, float yy)
{
	this->m[r * _cols + c].Y(yy);
}

//
//
//
void Mesh::Z(int r, int c, float zz)
{
	this->m[r * _cols + c].Z(zz);
}

//
//
//
void Mesh::NX(int r, int c, float nxx)
{
	this->m[r * _cols + c].NX(nxx);
}

//
//
//
void Mesh::NY(int r, int c, float nyy)
{
	this->m[r * _cols + c].NY(nyy);
}

//
//
//
void Mesh::NZ(int r, int c, float nzz)
{
	this->m[r * _cols + c].NZ(nzz);
}

//
//
//
float Mesh::X(int r, int c)
{
	return this->m[r * _cols + c].X();
}

//
//
//
float Mesh::Y(int r, int c)
{
	return this->m[r * _cols + c].Y();
}

//
//
//
float Mesh::Z(int r, int c)
{
	return this->m[r * _cols + c].Z();
}
//
//
//
float Mesh::NX(int r, int c)
{
	return this->m[r * _cols + c].NX();
}

//
//
//
float Mesh::NY(int r, int c)
{
	return this->m[r * _cols + c].NY();
}

//
//
//
float Mesh::NZ(int r, int c)
{
	return this->m[r * _cols + c].NZ();
}
