#if !defined(MESH_H)
#define MESH_H

class MeshNode
{

 public:

	void X(float xx)  { x = xx; }
	void Y(float yy)  { y = yy; }
	void Z(float zz)  { z = zz; }
	void NX(float xx) { nx = xx; }
	void NY(float yy) { ny = yy; }
	void NZ(float zz) { nz = zz; }

	float X()  { return x; }
	float Y()  { return y; }
	float Z()  { return z; }
	float NX() { return nx; }
	float NY() { return ny; }
	float NZ() { return nz; }

 private:

	float x;
	float y;
	float z;
	float nx;
	float ny;
	float nz;
};

class Mesh
{

 public:

	//
	// We have a regular constructor and a copy constructor.
	// The destructor frees the array created by the 
	// constructors.
	//
	Mesh(int rows, int columns);
	Mesh(Mesh &);
	~Mesh(){ delete [] m; } 

	//
	// Read access to the number of rows and columns.
	//
	int rows() const { return _rows; }
	int cols() const { return _cols; }

	//
	// Assignment operator.
	//
	Mesh & operator = (Mesh &);

	void X(int, int, float);
	void Y(int, int, float);
	void Z(int, int, float);
	void NX(int, int, float);
	void NY(int, int, float);
	void NZ(int, int, float);

	float X(int, int);
	float Y(int, int);
	float Z(int, int);
	float NX(int, int);
	float NY(int, int);
	float NZ(int, int);

	//
	// Read access to a particular mesh element.
	//
	MeshNode & operator() (int row, int column) 
	{ return m[row * cols() + column]; }

	const MeshNode & operator() (int row, int column) const
	{ return m[row * cols() + column]; }

 private:

	int        _rows;
	int        _cols;
	MeshNode * m;
};

#endif