#ifndef _INC_TEXTURE2D_
#define _INC_TEXTURE2D_

#include "matrix.h"
#include "color.h"
#include <windows.h>
#include <GL/glut.h>

class Texture2D : public Matrix<Color32> {
protected:
	GLuint name;
public:
	Texture2D(char* filename);
	Texture2D(int width, int height);
	int getWidth() const;
	int getHeight() const;
	GLuint getName();
	void setupTexture();
	void deleteTexture();
	void writeBMP(char* filename);
};

inline Texture2D::Texture2D(int width, int height) : Matrix<Color32>(width, height, COLUMN_MAJOR) { }

inline int Texture2D::getWidth() const { return numCols; }

inline int Texture2D::getHeight() const { return numRows; }

inline GLuint Texture2D::getName() { return name; }

#endif