#include <windows.h>
#include <GL/glut.h>
#include<stdio.h>
#include<math.h>
#include "Mesh.h"
#include "texture2d.h"

#define PI 3.141592654

float red=1.0, blue=1.0, green=1.0;
float width,height;

float camerax = 2;
float cameray =0;
float cameraz =2;

int count = 0;
int    N = 125;
float  u1[126][126];
float  u2[126][126];
float  u3[126][126];
float  p1;
float  p2;
float  delta;

float angle=0.0,deltaAngle = 0.0,ratio;  
float x=0.0f,y=1.75f,z=50.0f;		
float lx=2.0f,ly=0.0f,lz=2.0f;				
int deltaMove = 0;

Texture2D T("WaterInput.bmp");
Texture2D T1("stone.bmp");

Mesh * TheMesh;
Mesh * SetupMesh();

void   UpdateMesh();


float IC1(float x, float y)
{
	float d = x * x + y * y;

	if(d < 0.25)
		return 0.5 * exp(-900.0 * d);
	else
		return 0.0;
}

void DrawAxes(float AxesLength)
{
	//
	// The parameter AxesLength is the distance from the origin to the
	// tip of the arrow head. These parameters control the width and
	// length of the arrow head 
	//
	GLfloat a = 0.9f * AxesLength;
	GLfloat b = 0.025 * AxesLength;
	//
	// The x-axis shaft.
	//
	glBegin(GL_LINES);
	glColor3f(1.0f, 0.0, 0.0);
	glVertex3f(-AxesLength, 0.0f, 0.0f);
	glVertex3f(AxesLength, 0.0f, 0.0f);
	glEnd();
	//
	// The x-axis arrowheads.
	//
	glBegin(GL_TRIANGLES);
	glColor3f(0.0f, 1.0f, 0.0f);
	glVertex3f(AxesLength, 0.0f, 0.0f);
	glVertex3f(a, b, 0.0f);
	glVertex3f(a, -b, 0.0f);
	//
	glColor3f(0.0f, 0.0f, 1.0f);
	glVertex3f(AxesLength, 0.0f, 0.0f);
	glVertex3f(a, 0.0f, b);
	glVertex3f(a, 0.0f, -b);
	glEnd();
	//
	// The y-axis shaft.
	//
	glBegin(GL_LINES);
	glColor3f(0.0f, 1.0f, 0.0f);
	glVertex3f(0.0f, -AxesLength, 0.0f);
	glVertex3f(0.0f, AxesLength, 0.0f);
	glEnd();
	//
	// The y-axis arrowheads.
	//
	glBegin(GL_TRIANGLES);
	glColor3f(0.0f, 0.0f, 1.0f);
	glVertex3f(0.0f, AxesLength, 0.0f);
	glVertex3f(0.0f, a, b);
	glVertex3f(0.0f, a, -b);
	//
	glColor3f(1.0f, 0.0f, 0.0f);
	glVertex3f(0.0f, AxesLength, 0.0f);
	glVertex3f(b, a, 0.0f);
	glVertex3f(-b, a, 0.0f);
	glEnd();
	//
	// The z-axis shaft.
	//
	glBegin(GL_LINES);
	glColor3f(0.0f, 0.0f, 1.0f);
	glVertex3f(0.0f, 0.0f, -AxesLength);
	glVertex3f(0.0f, 0.0f, AxesLength);
	glEnd();
	//
	// The z-axis arrowheads.
	//
	glBegin(GL_TRIANGLES);
	glColor3f(0.0f, 1.0f, 0.0f);
	glVertex3f(0.0f, 0.0f, AxesLength);
	glVertex3f(0.0f, b, a);
	glVertex3f(0.0f, -b, a);
	//
	glColor3f(1.0f, 0.0f, 0.0f);
	glVertex3f(0.0f, 0.0f, AxesLength);
	glVertex3f(b, 0.0f, a);
	glVertex3f(-b, 0.0f, a);
	glEnd();
}


void DrawBoundingBox(float HalfSide)
{
	
	//glDisable(GL_DEPTH_TEST);	
	glEnable(GL_TEXTURE_2D);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	T1.deleteTexture();
	T1.setupTexture();
	glBindTexture(GL_TEXTURE_2D, T1.getName());

	glColor4f(0.5f,0.5f,0.5f,0.5f);		
	//glBlendFunc(GL_SRC_ALPHA,GL_ONE);	
	//glEnable(GL_BLEND);		

	glBegin(GL_QUADS);
	//glColor3f(1.0f, 1.0f, 0.5);

	glTexCoord2f(HalfSide, -HalfSide);glVertex3f( HalfSide,  HalfSide, -HalfSide);
	glTexCoord2f(HalfSide,  HalfSide);glVertex3f( HalfSide,  HalfSide,  HalfSide);

	glTexCoord2f(-HalfSide, HalfSide);glVertex3f(-HalfSide,  HalfSide,  HalfSide);
	glTexCoord2f(-HalfSide, -HalfSide);glVertex3f(-HalfSide,  HalfSide, -HalfSide);

	glEnd();

	glBegin(GL_QUADS);

	glTexCoord2f(-HalfSide, -HalfSide);glVertex3f(-HalfSide, -HalfSide, -HalfSide);
	glTexCoord2f(-HalfSide, HalfSide);glVertex3f(-HalfSide, -HalfSide,  HalfSide);

	glTexCoord2f(HalfSide, HalfSide);glVertex3f( HalfSide, -HalfSide,  HalfSide);
	glTexCoord2f(HalfSide, -HalfSide);glVertex3f( HalfSide, -HalfSide, -HalfSide);

	glEnd();

	glBegin(GL_QUADS);

	glTexCoord2f(HalfSide,  HalfSide);glVertex3f(-HalfSide,  HalfSide,   HalfSide);
	glTexCoord2f(HalfSide,  -HalfSide);glVertex3f(-HalfSide,  HalfSide,  -HalfSide);

	glTexCoord2f(-HalfSide, -HalfSide);glVertex3f(-HalfSide, -HalfSide,  -HalfSide);
	glTexCoord2f(-HalfSide,  HalfSide);glVertex3f(-HalfSide, -HalfSide,   HalfSide);

	glEnd();

	glBegin(GL_QUADS);

	glTexCoord2f(-HalfSide,  HalfSide);glVertex3f( HalfSide, -HalfSide,  HalfSide);
	glTexCoord2f(-HalfSide, -HalfSide);glVertex3f( HalfSide, -HalfSide, -HalfSide);

	glTexCoord2f(HalfSide,  HalfSide);glVertex3f( HalfSide,  HalfSide,  HalfSide);
	glTexCoord2f(HalfSide, -HalfSide);glVertex3f( HalfSide,  HalfSide, -HalfSide);

	glEnd();
	glDisable(GL_BLEND);		
	//glEnable(GL_DEPTH_TEST);

	/*glBegin(GL_QUADS);

	glVertex3f( HalfSide, -HalfSide,  HalfSide);
	glVertex3f( HalfSide,  HalfSide,  HalfSide);

	glVertex3f(-HalfSide, -HalfSide,  HalfSide);
	glVertex3f(-HalfSide,  HalfSide,  HalfSide);

	glEnd();

	glBegin(GL_QUADS);

	glVertex3f(-HalfSide, -HalfSide, -HalfSide);
	glVertex3f(-HalfSide,  HalfSide, -HalfSide);

	glVertex3f( HalfSide, -HalfSide, -HalfSide);
	glVertex3f( HalfSide,  HalfSide, -HalfSide);

	glEnd();*/

	//glDisable(GL_TEXTURE_2D);
}



void newMesh(void)
{
	int   r;
	int   c;
	float hu, hv, l;
	float x0 = -0.5f;
	float y0 =  0.5f;
	float x;
	float y;
	float z;

	delta = 1.0f / (float) N;
	p2    = 0.25f;
	p1    = 2.0f * (1.0f - 2.0f * p2);


	//
	for(r = 1; r < TheMesh->rows() - 1; r++)
	{
		for(c = 1; c < TheMesh->cols() - 1; c++)
		{
			x = x0 + delta * r;
			y = y0 - delta * c;
			z = IC1(x, y);

			u1[r][c] = z;
			u2[r][c] = u1[r][c];
			u3[r][c] = 0.0;

			TheMesh->X(r, c, x);
			TheMesh->Y(r, c, y);
			TheMesh->Z(r, c, z);
		}
	}

	//
	// Set up the initial normal vectors.
	//
	for(r = 0; r < TheMesh->rows(); r++)
	{
		for(c = 0; c < TheMesh->cols(); c++)
		{
			if(c == 0)
				hu = (TheMesh->Z(r, c + 1) - TheMesh->Z(r, c)) / delta;
			else
				if(c == N)
					hu = (TheMesh->Z(r, c + 1) - TheMesh->Z(r, c - 1)) / delta;
				else
					hu = (TheMesh->Z(r, c + 1) + TheMesh->Z(r, c - 1) - (2 * TheMesh->Z(r, c))) / (2 * delta);

			if(r == 0)
				hv = (TheMesh->Z(r + 1, c) - TheMesh->Z(r, c)) / delta;
			else
				if(r == N)
					hv = (TheMesh->Z(r, c) - TheMesh->Z(r - 1, c)) / delta;
				else
					hv = (TheMesh->Z(r + 1, c) + TheMesh->Z(r - 1, c) - (2 * TheMesh->Z(r, c))) / (2 * delta);


			l = sqrt(hu * hu + hv * hv + 1);

			TheMesh->NX(r, c, -hu / l);
			TheMesh->NY(r, c, -hv / l);
			TheMesh->NZ(r, c, 1.0 / l);
		}
	}

}

Mesh * SetupMesh()
{
	int   r;
	int   c;
	float hu, hv, l;
	float x0 = -0.5f;
	float y0 =  0.5f;
	float x;
	float y;
	float z;

	delta = 1.0f / (float) N;
	p2    = 0.25f;
	p1    = 2.0f * (1.0f - 2.0f * p2);

	//
	// Allocate a new Mesh object that is N + 1 square.
	//
	Mesh * mesh = new Mesh(N + 1, N + 1);
	//
	// Use a function to set the initial positions of the 
	// vertices.
	//
	for(r = 0; r < mesh->rows(); r++)
	{
		for(c = 0; c < mesh->cols(); c++)
		{
			x = x0 + delta * r;
			y = y0 - delta * c;
			z = IC1(x, y);

			u1[r][c] = z;
			u2[r][c] = u1[r][c];
			u3[r][c] = 0.0;

			mesh->X(r, c, x);
			mesh->Y(r, c, y);
			mesh->Z(r, c, z);
		}
	}

	//
	// Set up the initial normal vectors.
	//
	for(r = 0; r < mesh->rows(); r++)
	{
		for(c = 0; c < mesh->cols(); c++)
		{
			if(c == 0)
				hu = (mesh->Z(r, c + 1) - mesh->Z(r, c)) / delta;
			else
				if(c == N)
					hu = (mesh->Z(r, c + 1) - mesh->Z(r, c - 1)) / delta;
				else
					hu = (mesh->Z(r, c + 1) + mesh->Z(r, c - 1) - (2 * mesh->Z(r, c))) / (2 * delta);

			if(r == 0)
				hv = (mesh->Z(r + 1, c) - mesh->Z(r, c)) / delta;
			else
				if(r == N)
					hv = (mesh->Z(r, c) - mesh->Z(r - 1, c)) / delta;
				else
					hv = (mesh->Z(r + 1, c) + mesh->Z(r - 1, c) - (2 * mesh->Z(r, c))) / (2 * delta);


			l = sqrt(hu * hu + hv * hv + 1);

			mesh->NX(r, c, -hu / l);
			mesh->NY(r, c, -hv / l);
			mesh->NZ(r, c, 1.0 / l);
		}
	}

	return mesh;
}



void DrawMesh(Mesh * mesh)
{
	int num_rows = mesh->rows();
	int num_cols = mesh->cols();
	int r, c;
	float max = 0.0;
	float min = 0.0;

	for(r = 0; r < num_rows - 1; r++)
	{
		glBegin(GL_QUAD_STRIP);
		for(c = 0; c < num_cols; c++)
		{
			glTexCoord3f(mesh->X(r + 1, c), mesh->Y(r + 1, c), mesh->Z(r + 1, c));
			glNormal3f(mesh->NX(r + 1, c), mesh->NY(r + 1, c), mesh->NZ(r + 1, c));
			glVertex3f(mesh->X(r + 1, c), mesh->Y(r + 1, c), mesh->Z(r + 1, c));
			
			glTexCoord3f(mesh->X(r, c), mesh->Y(r, c), mesh->Z(r, c));
			glNormal3f(mesh->NX(r, c), mesh->NY(r, c), mesh->NZ(r, c));
			glVertex3f(mesh->X(r, c), mesh->Y(r, c), mesh->Z(r, c));
		}
		glEnd();
	}

}



void UpdateMesh()
{
	int   i;
	int   j;
	float tmp;
	float hu;
	float hv;
	float l;


	
	//
	// Update displacements.
	//
	for(i = 1; i < TheMesh->rows() - 1; i++)
	{
		for(j = 1; j < TheMesh->cols() - 1; j++)
		{
			//
			// Centered space finite difference.
			//
			tmp = p2 * (u2[i + 1][j] + u2[i - 1][j] + u2[i][j + 1] + u2[i][j - 1]);
			//
			// Centered time finite difference
			//
			tmp += (p1 * u2[i][j] - u1[i][j]);
			//
			// The update.
			//
			u3[i][j] = tmp*0.999;
			TheMesh->Z(i, j, tmp);
		}
	}
	//
	// Update normals.
	//
	for(i = 0; i < TheMesh->rows(); i++)
	{
		for(j = 0; j < TheMesh->cols(); j++)
		{

			if(j == 0)
				hu = (TheMesh->Z(i, j + 1) - TheMesh->Z(i, j)) / delta;
			else
				if(j == N)
					hu = (TheMesh->Z(i, j + 1) - TheMesh->Z(i, j - 1)) / delta;
				else
					hu = (TheMesh->Z(i, j + 1) + TheMesh->Z(i, j - 1) - (2 * TheMesh->Z(i, j))) / (2 * delta);

			if(i == 0)
				hv = (TheMesh->Z(i + 1, j) - TheMesh->Z(i, j)) / delta;
			else
				if(i == N)
					hv = (TheMesh->Z(i, j) - TheMesh->Z(i - 1, j)) / delta;
				else
					hv = (TheMesh->Z(i + 1, j) + TheMesh->Z(i - 1, j) - (2 * TheMesh->Z(i, j))) / (2 * delta);


			l = sqrt(hu * hu + hv * hv + 1);
			//
			// Compute the normals, assuming that the surface is a 
			// function of (x, y).
			//
			TheMesh->NX(i, j, -hu / l);
			TheMesh->NY(i, j, -hv / l);
			TheMesh->NZ(i, j, 1.0 / l);
		}
	}
	//
	// Prep for next pass.
	//
	for(i = 1; i < TheMesh->rows() - 1; i++)
	{
		for(j = 1; j < TheMesh->cols() - 1; j++)
		{
			u1[i][j] = u2[i][j];
			u2[i][j] = u3[i][j];
		}
	}

	if(count == 500)
	{
newMesh();
count = 0;
	}
	count++;


}



void orientMe(float ang) {


	lx = sin(ang);
	lz = -cos(ang);
	glLoadIdentity();
gluLookAt(camerax,cameray, cameraz, camerax-2,cameray-0,cameraz-2, 0.0f,0.0f,1.0f);
/*gluLookAt(x, y, z, 
		      x + lx,y + ly,z + lz,
			  0.0f,1.0f,0.0f);*/
}


void moveMeFlat(int i) {
	x = x + i*(lx)*0.1;
	y = y + i*(ly)*0.1;
	glLoadIdentity();
gluLookAt(camerax,cameray, cameraz, 0,0,0, 0.0f,0.0f,1.0f);
}

void pressKey(int key, int x, int y) {

	switch (key) {
		case GLUT_KEY_LEFT : deltaAngle = -0.01f;break;
		case GLUT_KEY_RIGHT : deltaAngle = 0.01f;break;
		case GLUT_KEY_UP: deltaMove = 1;break;
		case GLUT_KEY_DOWN : deltaMove = -1;break;
	}
}

void releaseKey(int key, int x, int y) {

	switch (key) {
		case GLUT_KEY_LEFT : 
		case GLUT_KEY_RIGHT : deltaAngle = 0.0f;break;
		case GLUT_KEY_UP : 
		case GLUT_KEY_DOWN : deltaMove = 0;break;
	}
}

void processNormalKeys(unsigned char key, int x, int y) {

	if (key == 27) 
		exit(0);
}

void display(void)
{



   if (deltaMove)
		moveMeFlat(deltaMove);
	if (deltaAngle) 
	{
		angle += deltaAngle;
		orientMe(angle);
	}

   glClear (GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT);
	
	

glDisable(GL_LIGHTING); 

	glPushMatrix();
	//DrawAxes(1.0f);

	DrawBoundingBox(0.5);
	glPopMatrix();

   	glEnable(GL_LIGHTING); 
	glEnable(GL_LIGHT0); 


	glPushMatrix();
	UpdateMesh();
	glPopMatrix();

	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glBindTexture(GL_TEXTURE_2D, T.getName());

	glPushMatrix();
	DrawMesh(TheMesh);
	glPopMatrix();

   glFlush ();
   
   glutSwapBuffers();

  // glDisable(GL_TEXTURE_2D);
}


void init (void) 
{
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);

	glEnable(GL_DEPTH_TEST);

   glClearColor (0.0, 0.0, 0.0, 0.0);
   glShadeModel (GL_FLAT);    
   
   T.setupTexture();

   TheMesh = SetupMesh();
   DrawMesh(TheMesh);

   	glEnable(GL_LIGHTING); 
	glEnable(GL_LIGHT0); 
}

void reshape (int w, int h)
{
   
	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).
	if(h == 0)
		h = 1;

	ratio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	// Set the clipping volume
	gluPerspective(35,ratio,1,10000);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(camerax-3,cameray, cameraz+1.0,3,0,-5, 0.1f,0.1f,0.1f);
}



int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutInitWindowPosition(20, 30); 
   glutInitWindowSize (900, 650);
   glutCreateWindow ("Water Surface Modeling");
   init ();
   glutIgnoreKeyRepeat(1);
   glutKeyboardFunc(processNormalKeys);
   glutSpecialFunc(pressKey);
   glutSpecialUpFunc(releaseKey);
   glutDisplayFunc(display);
   glutIdleFunc(display);
   glutReshapeFunc(reshape);

   glutMainLoop();

   return 0;  
}
